<html>
<head>
<title>OgreGLSLProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_4557aaee8cf510d5b035fe0c2c5dd433.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_81e02400f093837e2a11409f96e5fd4f.html">GLSL</a>      </li>
      <li class="navelem"><a class="el" href="dir_2fa9b21d57931d849b3ca4a2f6225bef.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00056"></a><a class="code" href="classOgre_1_1GLSLProgram.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdAttach.html">00060</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdAttach.html" title="Command object for attaching another GLSL Program.">CmdAttach</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00061"></a>00061         {
<a name="l00062"></a>00062         <span class="keyword">public</span>:
<a name="l00063"></a>00063             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00064"></a>00064             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; shaderNames);
<a name="l00065"></a>00065         };
<a name="l00066"></a>00066 
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, 
<a name="l00068"></a>00068             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00069"></a>00069             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00070"></a>00070         ~<a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a78387f03d86deb4bf3415f0a918052ad">00072</a>         GLhandleARB <a class="code" href="classOgre_1_1GLSLProgram.html#a78387f03d86deb4bf3415f0a918052ad">getGLHandle</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLHandle; }
<a name="l00073"></a>00073         <span class="keywordtype">void</span> attachToProgramObject( <span class="keyword">const</span> GLhandleARB programObject );
<a name="l00074"></a>00074         <span class="keywordtype">void</span> detachFromProgramObject( <span class="keyword">const</span> GLhandleARB programObject );
<a name="l00075"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a4b3f3e85a72c4582166e9d41fcf97492">00075</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a4b3f3e85a72c4582166e9d41fcf97492">getAttachedShaderNames</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAttachedShaderNames; }
<a name="l00076"></a>00076 
<a name="l00078"></a>00078         <span class="keywordtype">bool</span> getPassTransformStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00079"></a>00079         <span class="keywordtype">bool</span> getPassSurfaceAndLightStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> attachChildShader(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1GLSLProgram.html#ad16486aeb0ac1c15e4092ba9751b98b8">00085</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLProgram.html#ad16486aeb0ac1c15e4092ba9751b98b8" title="Sets the preprocessor defines use to compile the program.">setPreprocessorDefines</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; defines) { mPreprocessorDefines = defines; }
<a name="l00087"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a07a63456cfab5520479fa249c35c2a9c">00087</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GLSLProgram.html#a07a63456cfab5520479fa249c35c2a9c" title="Sets the preprocessor defines use to compile the program.">getPreprocessorDefines</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPreprocessorDefines; }
<a name="l00088"></a>00088 
<a name="l00090"></a>00090         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a996884059b83ccc3580d3628566ff873">00095</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> getInputOperationType(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00096"></a>00096 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mInputOperationType; }
<a name="l00099"></a><a class="code" href="classOgre_1_1GLSLProgram.html#ad5cf3f1ac7061052091e32b541e4889d">00099</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> getOutputOperationType(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00100"></a>00100 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mOutputOperationType; }
<a name="l00104"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a99766960803eff8130544f6f7e169937">00104</a>         <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1GLSLProgram.html#a99766960803eff8130544f6f7e169937" title="Returns the maximum number of vertices that this geometry program can output in a single run...">getMaxOutputVertices</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxOutputVertices; }
<a name="l00105"></a>00105 
<a name="l00108"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a310252b842fb357d7236c320dd6d65d8">00108</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInputOperationType(<a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> operationType) 
<a name="l00109"></a>00109         { mInputOperationType = operationType; }
<a name="l00112"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a674bae1b9f6f3850df9b547b3dae040b">00112</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOutputOperationType(<a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> operationType) 
<a name="l00113"></a>00113         { mOutputOperationType = operationType; }
<a name="l00117"></a><a class="code" href="classOgre_1_1GLSLProgram.html#aa5357dce29f1567b8d4866d3571ab2dd">00117</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaxOutputVertices(<span class="keywordtype">int</span> maxOutputVertices) 
<a name="l00118"></a>00118         { mMaxOutputVertices = maxOutputVertices; }
<a name="l00119"></a>00119 
<a name="l00121"></a>00121         <span class="keywordtype">bool</span> compile( <span class="keyword">const</span> <span class="keywordtype">bool</span> checkErrors = <span class="keyword">true</span>);
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdPreprocessorDefines.html">00124</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00125"></a>00125         {
<a name="l00126"></a>00126         <span class="keyword">public</span>:
<a name="l00127"></a>00127             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00128"></a>00128             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00129"></a>00129         };
<a name="l00131"></a><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdInputOperationType.html">00131</a>         <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdInputOperationType.html" title="Command object for setting the input operation type (geometry shader only)">CmdInputOperationType</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00132"></a>00132         {
<a name="l00133"></a>00133         <span class="keyword">public</span>:
<a name="l00134"></a>00134             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00135"></a>00135             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00136"></a>00136         };
<a name="l00138"></a><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdOutputOperationType.html">00138</a>         <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdOutputOperationType.html" title="Command object for setting the output operation type (geometry shader only)">CmdOutputOperationType</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140         <span class="keyword">public</span>:
<a name="l00141"></a>00141             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00142"></a>00142             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00143"></a>00143         };
<a name="l00145"></a><a class="code" href="classOgre_1_1GLSLProgram_1_1CmdMaxOutputVertices.html">00145</a>         <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdMaxOutputVertices.html" title="Command object for setting the maximum output vertices (geometry shader only)">CmdMaxOutputVertices</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00146"></a>00146         {
<a name="l00147"></a>00147         <span class="keyword">public</span>:
<a name="l00148"></a>00148             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00149"></a>00149             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00150"></a>00150         };
<a name="l00151"></a>00151     <span class="keyword">protected</span>:
<a name="l00152"></a><a class="code" href="classOgre_1_1GLSLProgram.html#af5982cc35e119360c5055c248f011bee">00152</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> <a class="code" href="classOgre_1_1GLSLProgram.html#af5982cc35e119360c5055c248f011bee">msCmdPreprocessorDefines</a>;
<a name="l00153"></a><a class="code" href="classOgre_1_1GLSLProgram.html#ad18bd48b6ff1199e20a877ddc401d58a">00153</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdAttach.html" title="Command object for attaching another GLSL Program.">CmdAttach</a> <a class="code" href="classOgre_1_1GLSLProgram.html#ad18bd48b6ff1199e20a877ddc401d58a">msCmdAttach</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a93a224c65027aa1a2826f7e2f91ab5f8">00154</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdInputOperationType.html" title="Command object for setting the input operation type (geometry shader only)">CmdInputOperationType</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a93a224c65027aa1a2826f7e2f91ab5f8">msInputOperationTypeCmd</a>;
<a name="l00155"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a5a7278d4418a0974e636864347e9fa91">00155</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdOutputOperationType.html" title="Command object for setting the output operation type (geometry shader only)">CmdOutputOperationType</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a5a7278d4418a0974e636864347e9fa91">msOutputOperationTypeCmd</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a84ed838297fba45f7409dca19751ec66">00156</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLProgram_1_1CmdMaxOutputVertices.html" title="Command object for setting the maximum output vertices (geometry shader only)">CmdMaxOutputVertices</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a84ed838297fba45f7409dca19751ec66">msMaxOutputVerticesCmd</a>;
<a name="l00157"></a>00157 
<a name="l00160"></a>00160         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00166"></a>00166         <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>);
<a name="l00168"></a>00168         <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00170"></a>00170         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00171"></a>00171 
<a name="l00173"></a>00173         <span class="keywordtype">void</span> populateParameterNames(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00175"></a>00175         <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keyword">private</span>:
<a name="l00179"></a><a class="code" href="classOgre_1_1GLSLProgram.html#aa195933dde494d02f48baae6aeb7d240">00179</a>         GLhandleARB <a class="code" href="classOgre_1_1GLSLProgram.html#aa195933dde494d02f48baae6aeb7d240" title="GL handle for shader object.">mGLHandle</a>;
<a name="l00181"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a197ffb44ef21f8cb87603ba0b365202c">00181</a>         GLint <a class="code" href="classOgre_1_1GLSLProgram.html#a197ffb44ef21f8cb87603ba0b365202c" title="Flag indicating if shader object successfully compiled.">mCompiled</a>;
<a name="l00183"></a><a class="code" href="classOgre_1_1GLSLProgram.html#aba1b23ce12ff54c2ae33a5e589f095ab">00183</a>         <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> <a class="code" href="classOgre_1_1GLSLProgram.html#aba1b23ce12ff54c2ae33a5e589f095ab" title="The input operation type for this (geometry) program.">mInputOperationType</a>;
<a name="l00185"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a953b938c4dc13c14f6c35735e965f245">00185</a>         <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a953b938c4dc13c14f6c35735e965f245" title="The output operation type for this (geometry) program.">mOutputOperationType</a>;
<a name="l00187"></a><a class="code" href="classOgre_1_1GLSLProgram.html#affeaabdd6920606378f3fc79c965239f">00187</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1GLSLProgram.html#affeaabdd6920606378f3fc79c965239f" title="The maximum amount of vertices that this (geometry) program can output.">mMaxOutputVertices</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a52ea7ce41c64d44b39ebcf8ff9152c46">00189</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a52ea7ce41c64d44b39ebcf8ff9152c46" title="attached Shader names">mAttachedShaderNames</a>;
<a name="l00191"></a><a class="code" href="classOgre_1_1GLSLProgram.html#ac26e0302231368928da90d8ac2507d3e">00191</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSLProgram.html#ac26e0302231368928da90d8ac2507d3e" title="Preprocessor options.">mPreprocessorDefines</a>;
<a name="l00193"></a><a class="code" href="classOgre_1_1GLSLProgram.html#a4d86df37e25a2c3049b0f08a4019dadb">00193</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt; GLSLProgram* &gt;::type</a> <a class="code" href="classOgre_1_1GLSLProgram.html#a4d86df37e25a2c3049b0f08a4019dadb" title="container of attached programs">GLSLProgramContainer</a>;
<a name="l00194"></a><a class="code" href="classOgre_1_1GLSLProgram.html#aecf5460f4873c3505eea1478d5537d3a">00194</a>         <span class="keyword">typedef</span> GLSLProgramContainer::iterator <a class="code" href="classOgre_1_1GLSLProgram.html#aecf5460f4873c3505eea1478d5537d3a">GLSLProgramContainerIterator</a>;
<a name="l00195"></a><a class="code" href="classOgre_1_1GLSLProgram.html#af94282f4513891d5a8e3667b233a8959">00195</a>         <a class="code" href="classOgre_1_1GLSLProgram.html#a4d86df37e25a2c3049b0f08a4019dadb" title="container of attached programs">GLSLProgramContainer</a> <a class="code" href="classOgre_1_1GLSLProgram.html#af94282f4513891d5a8e3667b233a8959">mAttachedGLSLPrograms</a>;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     };
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif // __GLSLProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
